/**
 * @copyright nhcarrigan
 * @license Naomi's Public License
 * @author Naomi Carrigan
 */

import type { Linter } from "eslint";

export const unicornRules: Linter.RulesRecord = {
  "unicorn/better-regex": "warn",
  "unicorn/catch-error-name":
  [ "warn", { name: "error" } ],
  "unicorn/consistent-destructuring":      "warn",
  "unicorn/consistent-empty-array-spread": "error",
  "unicorn/consistent-function-scoping":   "error",
  "unicorn/error-message":                 "error",
  "unicorn/escape-case":                   "warn",
  "unicorn/filename-case":
  [ "warn", { case: "camelCase" } ],
  "unicorn/no-array-callback-reference":             "error",
  "unicorn/no-array-for-each":                       "warn",
  "unicorn/no-array-method-this-argument":           "error",
  "unicorn/no-array-push-push":                      "warn",
  "unicorn/no-array-reduce":                         "warn",
  "unicorn/no-await-expression-member":              "warn",
  "unicorn/no-await-in-promise-methods":             "error",
  "unicorn/no-empty-file":                           "error",
  "unicorn/no-for-loop":                             "warn",
  "unicorn/no-hex-escape":                           "error",
  "unicorn/no-instanceof-array":                     "error",
  "unicorn/no-invalid-fetch-options":                "warn",
  "unicorn/no-keyword-prefix":                       "warn",
  "unicorn/no-length-as-slice-end":                  "warn",
  "unicorn/no-lonely-if":                            "warn",
  "unicorn/no-negation-in-equality-check":           "error",
  "unicorn/no-new-buffer":                           "error",
  "unicorn/no-object-as-default-parameter":          "warn",
  "unicorn/no-single-promise-in-promise-methods":    "warn",
  "unicorn/no-static-only-class":                    "warn",
  "unicorn/no-thenable":                             "warn",
  "unicorn/no-this-assignment":                      "warn",
  "unicorn/no-typeof-undefined":                     "error",
  "unicorn/no-unnecessary-await":                    "warn",
  "unicorn/no-unreadable-array-destructuring":       "warn",
  "unicorn/no-unreadable-iife":                      "warn",
  "unicorn/no-useless-promise-resolve-reject":       "warn",
  "unicorn/no-useless-spread":                       "warn",
  "unicorn/no-useless-switch-case":                  "warn",
  "unicorn/no-zero-fractions":                       "warn",
  "unicorn/number-literal-case":                     "warn",
  "unicorn/numeric-separators-style":                "warn",
  "unicorn/prefer-array-flat":                       "warn",
  "unicorn/prefer-array-flat-map":                   "warn",
  "unicorn/prefer-array-index-of":                   "warn",
  "unicorn/prefer-array-some":                       "warn",
  "unicorn/prefer-at":                               "warn",
  "unicorn/prefer-code-point":                       "error",
  "unicorn/prefer-date-now":                         "warn",
  "unicorn/prefer-default-parameters":               "warn",
  "unicorn/prefer-includes":                         "warn",
  "unicorn/prefer-math-trunc":                       "warn",
  "unicorn/prefer-modern-math-apis":                 "warn",
  "unicorn/prefer-module":                           "error",
  "unicorn/prefer-native-coercion-functions":        "error",
  "unicorn/prefer-negative-index":                   "warn",
  "unicorn/prefer-node-protocol":                    "warn",
  "unicorn/prefer-number-properties":                "error",
  "unicorn/prefer-object-from-entries":              "warn",
  "unicorn/prefer-optional-catch-binding":           "warn",
  "unicorn/prefer-prototype-methods":                "warn",
  "unicorn/prefer-regexp-test":                      "warn",
  "unicorn/prefer-set-has":                          "warn",
  "unicorn/prefer-set-size":                         "warn",
  "unicorn/prefer-spread":                           "warn",
  "unicorn/prefer-string-replace-all":               "warn",
  "unicorn/prefer-string-slice":                     "warn",
  "unicorn/prefer-string-starts-ends-with":          "warn",
  "unicorn/prefer-string-trim-start-end":            "warn",
  "unicorn/prefer-structured-clone":                 "warn",
  "unicorn/prefer-top-level-await":                  "warn",
  "unicorn/prefer-type-error":                       "warn",
  "unicorn/prevent-abbreviations":                   "warn",
  "unicorn/require-array-join-separator":            "error",
  "unicorn/require-number-to-fixed-digits-argument": "error",
};
